//
// Grass vertex shader for billboard approach
//

uniform float	time;
uniform	vec3	eyePos;
uniform vec3	up;
uniform vec3	right;

void main(void)
{
	vec4	vertex     = gl_Vertex + 0.7*vec4 ( (gl_MultiTexCoord0.z - 0.5)*right + (gl_MultiTexCoord0.y - 0.5)*up, 0.0 );
	float	d          = distance ( vertex.xyz, eyePos );
	float	alphaScale = 0.9 / ( 1 + d ) + 0.1;
	vec3	p          = vec3 ( gl_ModelViewMatrix * vertex );			// transformed point to world space
	
	gl_Position     = gl_ModelViewProjectionMatrix * vertex;
	gl_TexCoord [0] = vec4 ( gl_MultiTexCoord0.x, (1.0 - gl_MultiTexCoord0.y), gl_MultiTexCoord0.zw );
	gl_Color.a     *= alphaScale;
	
	if ( gl_TexCoord [0].y < 0.5 )
	{	
		float	angle1 = time + 0.5077 * gl_Vertex.x - 0.421 * gl_Vertex.z;
		float	angle2 = 1.31415 * time + 0.3 * gl_Vertex.y - 0.6 * gl_Vertex.z;
		
		gl_Position += 0.05*vec4 ( sin ( angle1 ), cos ( angle2 ), 0, 0 );
	}
}
